package de.szut.lf8_starter.project;

import de.szut.lf8_starter.project.dto.CreateProjectDto;
import de.szut.lf8_starter.project.dto.GetProjectDto;
import de.szut.lf8_starter.project.dto.UpdateProjectDto;
import jakarta.validation.Valid;
import org.springframework.stereotype.Service;

@Service
public class ProjectMapper {
    public ProjectEntity mapCreateDtoToEntity(CreateProjectDto createProjectDto) {
        ProjectEntity projectEntity = new ProjectEntity();

        projectEntity.setName(createProjectDto.getName());
        projectEntity.setComment(createProjectDto.getComment());
        projectEntity.setLeadingEmployee(createProjectDto.getLeadingEmployee());
        projectEntity.setEmployees(createProjectDto.getEmployees());
        projectEntity.setContractor(createProjectDto.getContractor());
        projectEntity.setContractorName(createProjectDto.getContractorName());
        projectEntity.setStartDate(createProjectDto.getStartDate());
        projectEntity.setPlannedEndDate(createProjectDto.getPlannedEndDate());
        projectEntity.setEndDate(createProjectDto.getEndDate());

        return projectEntity;
    }

    public GetProjectDto mapToGetDto(ProjectEntity projectEntity) {
        GetProjectDto getProjectDto = new GetProjectDto();

        getProjectDto.setId(projectEntity.getId());
        getProjectDto.setName(projectEntity.getName());
        getProjectDto.setComment(projectEntity.getComment());
        getProjectDto.setLeadingEmployee(projectEntity.getLeadingEmployee());
        getProjectDto.setEmployees(projectEntity.getEmployees());
        getProjectDto.setContractor(projectEntity.getContractor());
        getProjectDto.setContractorName(projectEntity.getContractorName());
        getProjectDto.setStartDate(projectEntity.getStartDate());
        getProjectDto.setPlannedEndDate(projectEntity.getPlannedEndDate());
        getProjectDto.setEndDate(projectEntity.getEndDate());

        return getProjectDto;
    }

    public ProjectEntity mapUpdateDtoToEntity(UpdateProjectDto updateProjectDto, ProjectEntity projectEntity) {
        projectEntity.setName(updateProjectDto.getName() != null ? updateProjectDto.getName() : projectEntity.getName());
        projectEntity.setLeadingEmployee(updateProjectDto.getLeadingEmployee() != null ? updateProjectDto.getLeadingEmployee() : projectEntity.getLeadingEmployee());
        projectEntity.setContractor(updateProjectDto.getContractor() != null ? updateProjectDto.getContractor() : projectEntity.getContractor());
        projectEntity.setContractorName(updateProjectDto.getContractorName() != null ? updateProjectDto.getContractorName() : projectEntity.getContractorName());
        projectEntity.setComment(updateProjectDto.getComment() != null ? updateProjectDto.getComment() : projectEntity.getComment());
        projectEntity.setStartDate(updateProjectDto.getStartDate() != null ? updateProjectDto.getStartDate() : projectEntity.getStartDate());
        projectEntity.setPlannedEndDate(updateProjectDto.getPlannedEndDate() != null ? updateProjectDto.getPlannedEndDate() : projectEntity.getPlannedEndDate());
        projectEntity.setEndDate(updateProjectDto.getEndDate() != null ? updateProjectDto.getEndDate() : projectEntity.getEndDate());

        if (updateProjectDto.getEmployees() != null) {
            projectEntity.getEmployees().clear();

            projectEntity.setEmployees(updateProjectDto.getEmployees());
        }

        return projectEntity;
    }
}
